// ======================================================================
// \title  HealthTopologyAc.hpp
// \author Generated by fpp-to-cpp
// \brief  hpp file for Health topology
// ======================================================================

#ifndef M_HealthTopologyAc_HPP
#define M_HealthTopologyAc_HPP

#include "C.hpp"
#include "Health.hpp"
#include "HealthTopologyDefs.hpp"

namespace M {

  // ----------------------------------------------------------------------
  // Constants
  // ----------------------------------------------------------------------

  namespace BaseIds {
    enum {
      health = 0x100,
      c1 = 0x200,
      c2 = 0x300,
    };
  }

  namespace InstanceIds {
    enum {
      c1,
      c2,
      health,
    };
  }

  // ----------------------------------------------------------------------
  // Component instances
  // ----------------------------------------------------------------------

  //! c1
  extern C c1;

  //! c2
  extern C c2;

  //! health
  extern Svc::Health health;

  // ----------------------------------------------------------------------
  // Helper functions
  // ----------------------------------------------------------------------

  //! Initialize components
  void initComponents(
      const TopologyState& state //!< The topology state
  );

  //! Configure components
  void configComponents(
      const TopologyState& state //!< The topology state
  );

  //! Set component base Ids
  void setBaseIds();

  //! Connect components
  void connectComponents();

  //! Register commands
  void regCommands();

  //! Read parameters
  void readParameters();

  //! Load parameters
  void loadParameters();

  //! Start tasks
  void startTasks(
      const TopologyState& state //!< The topology state
  );

  //! Stop tasks
  void stopTasks(
      const TopologyState& state //!< The topology state
  );

  //! Free threads
  void freeThreads(
      const TopologyState& state //!< The topology state
  );

  //! Tear down components
  void tearDownComponents(
      const TopologyState& state //!< The topology state
  );

  // ----------------------------------------------------------------------
  // Setup and teardown functions
  // ----------------------------------------------------------------------

  //! Set up the topology
  void setup(
      const TopologyState& state //!< The topology state
  );

  //! Tear down the topology
  void teardown(
      const TopologyState& state //!< The topology state
  );

}

#endif
